////////////////////////////////////////////////////////////////////////////////////////////////////
//	GLSL framework Camera interface. Written by Vladeta Stojanovic (0602920@live.abertay.ac.uk).
//	Version: 290111
////////////////////////////////////////////////////////////////////////////////////////////////////

#include <GLTools.h>
#include <GLFrame.h>
#include <math3d.h>

//camera class defines go here

#ifndef _CAMERA_H_
#define _CAMERA_H_

class Camera
{
public:

	//Default constructor
	Camera();

	//core functionality
	void InitCam();
	void UpdateCamera();
	void GetKeyboardInput();
	void GetMouseInput();
	void FPSWalk(float maxHeight, float height);

	inline float GetX()
	{
		return  m_cameraFrame.GetOriginX();
	}
	
	inline float GetY()
	{
		return  m_cameraFrame.GetOriginY();
	}
	
	inline float GetZ()
	{
		return  m_cameraFrame.GetOriginZ();
	}

	M3DMatrix44f mCamera;

	//Camera frame
	GLFrame m_cameraFrame;
};

extern Camera g_Camera;

#endif