//Skybox interface implementation.

#include "SkyBox.h"

using namespace std;
using namespace noise;

SkyBox::SkyBox()
{
	srand(time(NULL));
}

SkyBox::~SkyBox()
{

}

void SkyBox::GenerateSkybox()
{
	randClouds = rand();
	cloudBase.SetSeed (randClouds);
	cloudBase.SetFrequency (2.0);
	cloudBase.SetPersistence (0.375);
	cloudBase.SetLacunarity (2.12109375);
	cloudBase.SetOctaveCount (4);
	cloudBase.SetNoiseQuality (QUALITY_BEST);

	finalClouds.SetSourceModule (0, cloudBase);
	finalClouds.SetSeed (randClouds);
	finalClouds.SetFrequency (16.0);
	finalClouds.SetPower (1.0 / 64.0);
	finalClouds.SetRoughness (2);
}

void SkyBox::RenderCubeFaces()
{
		plane.SetBounds (-1.0, 1.0, -1.0, 1.0);
		plane.SetDestSize (SKYSIZE, SKYSIZE);
		plane.EnableSeamless (true);
		plane.SetSourceModule (finalClouds);
		plane.SetDestNoiseMap (noiseMap);
		plane.Build();

		textureRenderer.ClearGradient();
		textureRenderer.AddGradientPoint (-1.00, utils::Color ( 48,  64, 192, 255));
		textureRenderer.AddGradientPoint ( 0.50, utils::Color ( 96, 192, 255, 255));
		textureRenderer.AddGradientPoint ( 1.00, utils::Color (255, 255, 255, 255));
		textureRenderer.SetSourceNoiseMap (noiseMap);
		textureRenderer.SetDestImage(destTexture);
		textureRenderer.Render();

		textureWriter.SetSourceImage(destTexture);
		textureWriter.SetDestFilename("../data/skyTex.bmp");
		textureWriter.WriteDestFile();
}