//////////////////////////////////////////////////////////////////////////
// Skybox class. Used to generate and display the skybox.
//
// Written by Vladeta Stojanovic (0602920@live.abertay.ac.uk)
//
// Version: 250411_01
/////////////////////////////////////////////////////////////////////////

#ifndef _SKYBOX_H_
#define _SKYBOX_H_

#include "noiseutils.h"
#include <time.h>
#include <iostream>

using namespace noise;

#define SKYSIZE 512

class SkyBox
{
public:

	SkyBox();

	~SkyBox();

	void GenerateSkybox();

	void RenderCubeFaces();

private:

	module::Billow					cloudBase;
	module::Turbulence				finalClouds;
	utils::NoiseMapBuilderPlane		plane;
	utils::NoiseMap					noiseMap;
	utils::RendererImage			textureRenderer;
	utils::Image					destTexture;
	utils::WriterBMP				textureWriter;
	int								randClouds;
};

extern SkyBox gSkybox;

#endif