///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// TestTerrain.h 
// A very basic interface for procedural terrain generation. Written by Vladeta Stojanovic (0602920@live.abertay.ac.uk)
// Based on the code provided by Matt Bett.
//
// Version: 110211
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <GLBatch.h>
#include <GLTools.h>
#include <math3d.h>

#define MAXTERRAINSIZE 512

#ifndef _TESTTERRAIN_H_
#define _TESTTERRAIN_H_

class TestTerrain
{
public:

	//Constructor
	TestTerrain();

	//Destructor (can inherit)
	~TestTerrain();

	//Core member functions
	void Init();
	void ReGenerate();
	void Render();

	float mYField[262144];

	inline float GetYFieldVertValue(int i, int j)
	{
		return vVertex[i][j][1];
	}

	inline float GetXFieldVertValue()
	{
		for(int i = 0; i < 512 ; ++i)
		{
			for(int j = 0; j < 512; ++j)
			{
				return vVertex[i][j][0];
			}
		}
	}

	inline float GetZFieldVertValue()
	{
		for(int i = 0; i < 512 ; ++i)
		{
			for(int j = 0; j < 512; ++j)
			{
				return vVertex[i][j][2];
			}
		}
	}

private:

	//Test terrain class data members
	M3DVector3f vVertex[MAXTERRAINSIZE][MAXTERRAINSIZE];
	M3DVector3f vNormal[MAXTERRAINSIZE][MAXTERRAINSIZE];
	M3DVector2f vTexCoord[MAXTERRAINSIZE][MAXTERRAINSIZE];
	GLBatch	terrainBatch;
};

//extern me
extern TestTerrain g_Terrain;

#endif