// Water body interface. Written by Vladeta Stojanovic.
//
// Version: 130411_01

#ifndef _WATER_H_
#define _WATER_H_

#include <GLBatch.h>
#include <GLTools.h>
#include <math3d.h>
#include "noiseutils.h"
using namespace noise;

#define WATERSIZE 512

class Water
{
public:

	Water();

	~Water();

	void InitWater();

	void UpdateWater(float dT);

	void RenderWater();

	void GenerateWaterTex();

private:

	//Test terrain class data members
	M3DVector3f vVertex[WATERSIZE][WATERSIZE];
	M3DVector3f vNormal[WATERSIZE][WATERSIZE];
	M3DVector2f vTexCoord[WATERSIZE][WATERSIZE];
	GLBatch	waterBatch;

	//Water texture genetation stuff
	module::Voronoi					baseWater;
	module::ScalePoint				baseStretchedWater;
	module::Turbulence				finalWater;
	utils::NoiseMapBuilderPlane		plane;
	utils::NoiseMap					noiseMap;
	utils::RendererImage			textureRenderer;
	utils::Image					destTexture;
	utils::WriterBMP				textureWriter;
	int								randWater;

};

extern Water gWater;

#endif