#ifndef IGAME_H
#define IGAME_H
#include <memory>
class IInput;

class IGame 
{
public:
    IGame::IGame(std::tr1::shared_ptr<IInput> input );

    // Called once prior to the call(s) to Update.
    virtual	bool OnStartUp()	=	0;

    // Passed the number of seconds elapsed since the last call.
    virtual void Update(const float dtSeconds) = 0;

    // Called once after final call to Update.
    virtual void OnShutDown()		=	0;

    // Called when the window has resized.
    virtual void OnWindowResized( const int newWidth, const int newHeight ) = 0;

	//Called when the window has been moved if not full screened
	virtual void OnWindowMoved(const int newX, const int newY) = 0;

protected:
	std::tr1::shared_ptr<IInput> input_;
};


#endif // IGAME_H
