#include <windows.h>
#include "iwindow.h"
#include "igame.h"
#include "gamefactory.h"
#include "iinput.h"
#include "console.h"

// Entry point into the application
int WINAPI WinMain (HINSTANCE hInstance, 
					HINSTANCE hPrevInstance,
                    PSTR szCmdLine, 
					int nCmdShow)	
{
	//use the factory to create our objects.
	std::tr1::shared_ptr<IInput> input = get_game_input();
	std::tr1::shared_ptr<IGame> game = get_game(input);
	std::tr1::shared_ptr<IWindow> window = get_game_window( game, input, &hInstance );

	
	//run debug
	ShowWin32Console();

	window->Run();			// Run the application

	return 0;
}
